function   draw_isosurface(self, gv, context)
    conns = get(self, 'conn'); % connectivity
    [f,v]= isosurf_faces(self, conns, context.x, context.u, context.scalarfield, context.isovalue, 5);
    
    if (isfield(context,'color'))
        color =context.color;
    else
        color =[1,1,1]/2;
    end
    
    facealpha = 1;
    if (isfield(context,'facealpha'))
        facealpha = context.facealpha;
    end
    patch('Faces',f,'Vertices',v,'FaceColor',color,'EdgeColor','none','FaceAlpha', facealpha);
end
