

function Cylindrical_shell
    %     nu= 0.4876;
    %     mu=6000;
    %     kappa=240000;%MPa
    %     E =2*(1+nu)*mu;
%     nu= 0.4;
    mu=6000;
    kappa=24000;%MPa[x,y]=solve ('24000-x/3/( 1-2*y)','6000-x/2/(1+y)')
    E =1.6615e+004;
    nu=0.3846;
    alpha=  0.2*mu/2;
    alpha=  0.08*mu/2;
    alpha=  0.001*mu/2;
    alpha=  10*0.2*mu/2;
    alpha=  0.01*mu/2;
    %     E/3/( 1-2*nu)
    rho=5e-9;
    nus = [(1:100)*0+nu];
    %
    iR= 8;
    Thickness =2;
    Length =15;
    rA=pi;
    tol= 0.001;
    Fmag=-7500/15;

    nincr = 5;
    graphics =~false;
    scale=1;
    nas = (8:-1:1);
    nas = (1:4);
    nas = 2;
    na = 3;
    nc = 2*[na];
    nt = 4;

    %
    function [fens,gcells] = h8cylH8()
        [fens,gcells]=block(rA, Thickness, Length, nc,nt,na);
    end
    function [fens,gcells] = t4cyl()
        [fens,gcells]=t4block(rA, Thickness, Length, nc,nt,na);
    end
    function [fens,gcells] = t4cyld()
        [fens,gcells]=t4blocka(rA, Thickness, Length, nc,nt,na);
        [fens1,gcells1]=t4blockb(rA, Thickness, Length, nc,nt,na);
        [fens,gcells1,gcells2] = merge_meshes(fens1, gcells1, fens, gcells, 1/1000);
        gcells=cat(2,gcells1,gcells2);
    end
    function [fens,gcells] = h8cylH27()
        [fens,gcells] = h8cylH8();
        [fens,gcells] = H8_to_H27(fens,gcells);
    end
    function [fens,gcells] = h8cylH64()
        [fens,gcells] = h8cylH8();
        [fens,gcells] = H8_to_H64(fens,gcells);
    end


    eix=1;
    clear eltyd

   
    %
%     eltyd(eix).label ='H8';
%     eltyd(eix).mf =@h8cylH8;
%     eltyd(eix).blf =@feblock_defor_nonlinear;
%     eltyd(eix).integration_rule= gauss_rule (3,2);
%     eltyd(eix).line_integration_rule=gauss_rule (1,2);
%     eltyd(eix).styl='rx-.';
%     eix=eix+1;
    %
%     eltyd(eix).label ='NICE-T4';
%     eltyd(eix).mf =@t4cyl;
%     eltyd(eix).blf =@feblock_defor_nonlinear_nice;
%     eltyd(eix).integration_rule= simplex_nq_rule (3);
%     eltyd(eix).line_integration_rule=tri_rule(1);
%     eltyd(eix).styl='m^-';
%     eix=eix+1;

%     eltyd(eix).label ='NICE-T4d';
%     eltyd(eix).mf =@t4cyld;
%     eltyd(eix).blf =@feblock_defor_nonlinear_nice;
%     eltyd(eix).integration_rule= simplex_nq_doubled_rule (3);
%     eltyd(eix).line_integration_rule=gauss_rule(1, 3);
%     eltyd(eix).styl='m^-';
%     eix=eix+1;
    %
    eltyd(eix).label ='NICE-H8';
    eltyd(eix).mf =@h8cylH8;
    eltyd(eix).blf =@feblock_defor_nonlinear_nice;
    eltyd(eix).integration_rule= tensprod_nq_rule (struct('dim',3,'order',1));
    eltyd(eix).line_integration_rule=tensprod_nq_rule (struct('dim',1,'order',1));
    eltyd(eix).styl='md-';
    eix=eix+1;

    
%     eltyd(eix).label ='H27';
%     eltyd(eix).mf =@h8cylH27;
%     eltyd(eix).blf =@feblock_defor_nonlinear;
%     eltyd(eix).integration_rule=gauss_rule (3,3);
%     eltyd(eix).line_integration_rule=gauss_rule(1, 3);
%     eltyd(eix).styl='ks-';
%     eix=eix+1;

%     eltyd(eix).label ='NICE-H27';
%     eltyd(eix).mf =@h8cylH27;
%     eltyd(eix).blf =@feblock_defor_nonlinear_nice;
%     eltyd(eix).integration_rule=tensprod_nq_rule (struct('dim',3,'order',2));
%     eltyd(eix).line_integration_rule=tensprod_nq_rule (struct('dim',1,'order',2));
%     eltyd(eix).styl='mh-';
%     eix=eix+1;

%     eltyd(eix).label ='NICE-H64';
%     eltyd(eix).mf =@h8cylH64;
%     eltyd(eix).blf =@feblock_defor_nonlinear_nice;
%     eltyd(eix).integration_rule=tensprod_nq_rule (struct('dim',3,'order',3));
%     eltyd(eix).line_integration_rule=tensprod_nq_rule (struct('dim',1,'order',3));
%     eltyd(eix).styl='mh-';
%     eix=eix+1;


    function [utip] =Compute
        %                   Mesh
        [fens,gcells] = eltyd(eix).mf ();
        feb = eltyd(eix).blf (struct ('mater',[], 'gcells',gcells));
        [fens, gcells]=renum_mesh_renumber(fens, gcells,...
            renum_mesh_numbering(fens,genconn(feb), 'symamd'));
        bgcells =mesh_bdry(gcells, []);
        icl = gcell_select(fens, bgcells, struct('box', [rA,rA,-Inf,Inf,-Inf,Inf],'inflate',tol));
        bgcells =mesh_bdry(bgcells(icl), []);
        icl = gcell_select(fens, bgcells, struct('box', [rA,rA,0,0,-Inf,Inf],'inflate',2*tol));

        cncl = fenode_select(fens, struct('box', [rA,rA,0,0,Length,Length ],'inflate',tol));
        for i=1:length (fens)
            xyz=get (fens(i),'xyz');
            x=xyz(1); y=xyz(2); z=xyz(3);
            xyz= [0, y-iR-Thickness, z];
            xyz = xyz*rotmat([0, 0, -x])+ [0,iR+Thickness,0];
            fens(i)=set(fens(i),'xyz', xyz);
        end
        %         gv=drawmesh( {fens,gcells});
        %         gv=drawmesh( {fens,bgcells(icl)},'gv',gv,'facecolor','blue');
        %         view(3); return
        % MaterialAnd
        prop = property_linel_iso (struct('E',E,'nu',nu));
        mater = mater_defor_neohook(struct('property',prop));
        % Finite element block
        feb = eltyd(eix).blf (struct ('mater',mater, 'gcells',gcells,...
            'integration_rule',eltyd(eix).integration_rule));
        efeb = eltyd(eix).blf (struct ('mater',mater, 'gcells',bgcells(icl),...
            'integration_rule',eltyd(eix).line_integration_rule));
        sfeb = eltyd(eix).blf (struct ('mater',mater, 'gcells',bgcells,...
            'integration_rule',eltyd(eix).line_integration_rule));
        % Geometry
        geom = field(struct ('name',['geom'], 'dim', 3, 'fens',fens));
        % Define the displacement field
        u   = 0*geom; % zero out
        % Apply EBC's
        ebc_fenids=fenode_select (fens,struct('box',[0,0,0,0,0,Length],'inflate',tol));
        ebc_prescribed=ones(1,length (ebc_fenids));
        ebc_comp=ebc_fenids*0+1;
        ebc_val=ebc_fenids*0;
        u   = set_ebc(u, ebc_fenids, ebc_prescribed, ebc_comp, ebc_val);
        ebc_fenids=fenode_select (fens,struct('box',[0,0,0,0,0,Length],'inflate',tol));
        ebc_prescribed=ones(1,length (ebc_fenids));
        ebc_comp=ebc_fenids*0+2;
        ebc_val=ebc_fenids*0;
        u   = set_ebc(u, ebc_fenids, ebc_prescribed, ebc_comp, ebc_val);
        %         ebc_fenids=fenode_select (fens,struct('box',[0,0,0,0,0,Length],'inflate',tol));
        %         ebc_prescribed=ones(1,length (ebc_fenids));
        %         ebc_comp=[];
        %         ebc_val=ebc_fenids*0;
        %         u   = set_ebc(u, ebc_fenids, ebc_prescribed, ebc_comp, ebc_val);
        ebc_fenids=fenode_select (fens,struct('box',[-Inf,Inf,-Inf,Inf,0,0],'inflate',tol));
        ebc_prescribed=ones(1,length (ebc_fenids));
        ebc_comp=ebc_fenids*0+3;
        ebc_val=ebc_fenids*0;
        u   = set_ebc(u, ebc_fenids, ebc_prescribed, ebc_comp, ebc_val);
        ebc_fenids=fenode_select (fens,struct('box',[0,0,-Inf,Inf,0,Length],'inflate',tol));
        ebc_prescribed=ones(1,length (ebc_fenids));
        ebc_comp=ebc_fenids*0+1;
        ebc_val=ebc_fenids*0;
        u   = set_ebc(u, ebc_fenids, ebc_prescribed, ebc_comp, ebc_val);
        u   = apply_ebc (u);

        % Number equations
        u   = numbereqns (u);
        % Now comes the nonlinear solution
        tup = 1;
        u = u*0; % zero out the displacement
        utol = 1e-15*get(u, 'neqns');
        us={};

        if graphics, gv=graphic_viewer; end

        K = start (sparse_altassem_sysmat, get(u, 'neqns'));
        %         K = start (sparse_sysmat, get(u, 'neqns'));

        t=0; % time=load magnitude
        incr=1;
        while (incr <= nincr)
            t = t + tup / nincr;
            disp(['Increment ' num2str(incr) ]); % pause
            % Initialization
            u1 = u; % guess
            u1 = apply_ebc(u1);
            du = 0*u; % this will hold displacement increment
            du = apply_ebc(du);
            iter=1;
            if graphics,
                gv=reset(clear(gv,[]),[]);
                draw(feb,gv, struct ('x', geom,'u',u, 'facecolor','red'));
                draw(feb,gv, struct ('x', geom,'u',0*u, 'facecolor','Yellow'));
                Cam =camget(gv);
            end
            while 1
                prop = property_linel_iso (struct('E',E,'nu',nus(iter)));
                %                 ckappa=E / 3 / (1 - 2*(nus(iter)))
                mater = mater_defor_neohook(struct('property',prop));
                feb1=set(feb,'mater',mater);
                %                 feb1=feb;                                           % Make a copy of the state
                fi=force_intensity(struct('magn',[0;Fmag*t;0]));
                F = start (sysvec, get(u, 'neqns'));
                F = assemble (F, distrib_loads(efeb, geom, u, fi, 1));
%                 sum(get(F,'vec'))
                [feb1,evs] = restoring_force(feb1,geom,u1,u);       % Internal forces
                F = assemble (F, evs);
                [febstab,evs] = restoring_force_stab(feb1,geom,u1,u,alpha);       % Internal forces
                F = assemble (F, evs);
                ems=stiffness(feb1, geom, u1,u);% Current material stiffness
                K = assemble (K, ems);
                ems =stiffness_geo(feb1, geom, u1,u); % Current geometric stiffness
                K = assemble (K, ems);
                ems =stiffness_stab(feb1, geom, u1,u,alpha); % Current geometric stiffness
                K = assemble (K, ems);
                K = external_decomposition (K,  []);
                du = scatter_sysvec(du, K\F); % Displacement increment
                %                 max(abs(get(F,'vec')))
                u1 = u1 + du;                                       % increment displacement
                K = reinitialize (K);
                %                 draw(sfeb,gv, struct ('x', geom,'u',u1, 'facecolor','none'));
                if graphics, camset (gv,Cam); pause(0.5); Cam =camget(gv); end
                disp(['   It. ' num2str(iter) ': ||du||=' num2str(norm(du))]);
                if (max(abs(gather(du,[],'values'))) < utol) break; end;                    % convergence check
                iter=iter+1;
            end
            [feb,ignore] = restoring_force(feb,geom,u1,u);        % final update
            disp(['    Converged for t=' num2str(t)]); % pause
            u = u1;                                               % update the displacement
            us{end+1} =u;
            utip=gather(u,cncl,'values','noreshape');
            utip=utip(2)
            incr = incr + 1;
        end
        if graphics,
            gv=reset(clear(gv,[]),[]);
            draw(feb,gv, struct ('x', geom,'u',u, 'facecolor','red'));
            draw(feb,gv, struct ('x', geom,'u',0*u, 'facecolor','Yellow'));
        end
        %         camset(gv, [  -75.6602  613.9688  210.2074   20.6651   38.3517 20.5774         0         0    1.0000    5.3084]);
        clear K
        save ([mfilename '-nc' num2str(nc) '-nt' num2str(nt) '-' eltyd(eix).label])
    end

    for eix = 1:length(eltyd)
        utips = [];
        for na =nas
            nc=2*na;
            utips(end+1)=Compute
        end
        disp(eltyd(eix).label);
        disp([nas;utips]);
        save intermedres.mat nas utips
    end
end