font='Times';
Legends = {};
Data = {};
Style = {};

% loadv=[0;0;p];dir=3;uzex=5.426e-3;
% loadv=[0;p;0];dir=2;
uzex=-16.901;
%uzex=15.41;

Data{end+1}=[
   0 32
  uzex uzex
]; Style{end+1}='k--'; Legends{end+1} ='Ref';


Data{end+1}=[
   4, 8, 16, 32
   -8.75,-15.2,-16.45,-16.6
]; Style{end+1}='k-'; Legends{end+1} ='F Q2/Q1';
Data{end+1}=[
   8, 16, 32
   -13,-15.6, -16.4
]; Style{end+1}='k-.'; Legends{end+1} ='Q1SP';

% H8 nc=10 nt=2 stabfact=300
Data{end+1}=[
    4.0000    6.0000    8.0000   10.0000
   -1.6353   -3.6553   -5.6944   -7.5187
]; Style{end+1}='rx-.'; Legends{end+1} ='H8';
% NICE-T4 nc=10 nt=2 stabfact=300
Data{end+1}=[
    4.0000    6.0000    8.0000   10.0000
   -0.7002   -1.9448   -2.6191   -3.0274
]; Style{end+1}='m^-'; Legends{end+1} ='NICE-T4';
% NICE-T4d nc=10 nt=2 stabfact=300
Data{end+1}=[
    4.0000    6.0000    8.0000   10.0000
   -1.9183  -13.3420  -12.2100  -12.3544
]; Style{end+1}='mv-'; Legends{end+1} ='NICE-T4d';
% NICE-H8 nc=10 nt=2 stabfact=300
Data{end+1}=[
    4.0000    6.0000    8.0000   10.0000
   -1.4447   -8.5129  -10.7240  -11.0355
]; Style{end+1}='md-'; Legends{end+1} ='NICE-H8';






for j=1:length(Data)
    data=Data{j};
    h=data(1,:); utip=-data(2,:);
    plot(h,utip,Style{j},'lineWIDTH', 2); hold on;
%     loglog(h,abs(utip-uzex)/uzex,Style{j},'lineWIDTH', 2); hold on;
end

% set(gca,'XLim', [100, 1000]);
% set(gca,'YLim', [0.e-3, 2.25e-3]);
xlabel ('number of elements per side')
ylabel ('Displacement error')
legend(Legends,'Location','Southeast')
set(gca,'Position',[0.15 0.15 0.5 0.5]);
set_label_defaults
hold on; grid on; figure (gcf);
% saveas(gcf,[mfilename '.png']);
 printeps(gcf,[mfilename '.eps']);
%  close  all