

function Stumble
    E =0.1;
    nu=0.3846;
    stabfact=  0.2*E/2;
    %     E/3/( 1-2*nu)
    rho=5e-9;
    nus = [(1:100)*0+nu];
    vini =-1000;
    Newmarkb = 1/4; Newmarkg = 1/2;
    %
   DimensionA= 1;
  DimensionB= 1;
    Length =16;
    tol= 0.001;
    
    maxit = 30;
    tup = 0.1;
    nincr =800;
    dt =tup / nincr;

    graphics =~false;
    cam = [-78.7157   80.9309   71.1514    1.5000 1.0000    7.5000         0         0 1.0000    6.5474];
    scale=1;
    nas = 1;
    nbs = 3;
    nLs = 4;
     
   
    Report =@(x) (disp(x) );
%     Report =@(x) ([]);
   
    
    na = 3;
    nb = 2;
    nL = 19;
  %
    function [fens,gcells] = h8Mesh()
        [fens,gcells]=block(DimensionA, DimensionB, Length, na,nb,nL);
    end
    function [fens,gcells] = t4Mesh()
        [fens,gcells]=t4block(DimensionA, DimensionB, Length, na,nb,nL);
    end
    function [fens,gcells] = h8cylH27()
        [fens,gcells] = h8Mesh();
        [fens,gcells] = H8_to_H27(fens,gcells);
    end
    

    eix=1;
    clear eltyd

 
%     eltyd(eix).label ='H8';
%     eltyd(eix).mf =@h8Mesh;
%     eltyd(eix).blf =@feblock_defor_nonlinear;
%     eltyd(eix).integration_rule= gauss_rule (3,2);
%     eltyd(eix).line_integration_rule=gauss_rule (1,2);
%     eltyd(eix).stabfact =stabfact;
%     eltyd(eix).styl='rx-.';
%     eix=eix+1;
   
%     eltyd(eix).label ='NICE-T4';
%     eltyd(eix).mf =@t4Mesh;
%     eltyd(eix).blf =@feblock_defor_nonlinear_nice;
%     eltyd(eix).integration_rule= simplex_nq_rule (3);
%     eltyd(eix).line_integration_rule=tri_rule(1);
%     eltyd(eix).stabfact =stabfact;
%     eltyd(eix).styl='m^-';
%     eix=eix+1;

    eltyd(eix).label ='NICE-H8';
    eltyd(eix).mf =@h8Mesh;
    eltyd(eix).blf =@feblock_defor_nonlinear_nice;
    eltyd(eix).integration_rule= tensprod_nq_rule (struct('dim',3,'order',1));
    eltyd(eix).line_integration_rule=tensprod_nq_rule (struct('dim',1,'order',1));
    eltyd(eix).stabfact =stabfact;
    eltyd(eix).styl='md-';
    eix=eix+1;

%     eltyd(eix).label ='NICE-T4d';
%     eltyd(eix).mf =@t4cyld;
%     eltyd(eix).blf =@feblock_defor_nonlinear_nice;
%     eltyd(eix).integration_rule= simplex_nq_rule (3);
%     eltyd(eix).line_integration_rule=gauss_rule(1, 3);
%     eltyd(eix).stabfact =stabfact/4;
%     eltyd(eix).styl='mv-';
%     eix=eix+1;
    
%     eltyd(eix).label ='H27';
%     eltyd(eix).mf =@h8cylH27;
%     eltyd(eix).blf =@feblock_defor_nonlinear;
%     eltyd(eix).integration_rule=gauss_rule (3,3);
%     eltyd(eix).line_integration_rule=gauss_rule(1, 3);
%     eltyd(eix).styl='ks-';
%     eix=eix+1;

%     eltyd(eix).label ='NICE-H27';
%     eltyd(eix).mf =@h8cylH27;
%     eltyd(eix).blf =@feblock_defor_nonlinear_nice;
%     eltyd(eix).integration_rule=tensprod_nq_rule (struct('dim',3,'order',2));
%     eltyd(eix).line_integration_rule=tensprod_nq_rule (struct('dim',1,'order',2));
%     eltyd(eix).styl='mh-';
%     eix=eix+1;

%     eltyd(eix).label ='NICE-H64';
%     eltyd(eix).mf =@h8cylH64;
%     eltyd(eix).blf =@feblock_defor_nonlinear_nice;
%     eltyd(eix).integration_rule=tensprod_nq_rule (struct('dim',3,'order',3));
%     eltyd(eix).line_integration_rule=tensprod_nq_rule (struct('dim',1,'order',3));
%     eltyd(eix).styl='mh-';
%     eix=eix+1;


    function [utip] =Compute
        %                   Mesh
        [fens,gcells] = eltyd(eix).mf ();
        feb = eltyd(eix).blf (struct ('mater',[], 'gcells',gcells));
        [fens, gcells]=renum_mesh_renumber(fens, gcells,...
            renum_mesh_numbering(fens,genconn(feb), 'symamd'));
        
        cncl = fenode_select(fens, struct('box', [0,0,0,0,Length,Length ],'inflate',tol));
        %         gv=drawmesh( {fens,gcells});
        %         gv=drawmesh( {fens,bgcells(icl)},'gv',gv,'facecolor','blue');
        %         view(3); return
        % 
        prop = property_linel_iso (struct('E',E,'nu',nu,'rho',rho));
        mater = mater_defor_neohook(struct('property',prop));
        % Finite element block
        feb = eltyd(eix).blf (struct ('mater',mater, 'gcells',gcells,...
            'integration_rule',eltyd(eix).integration_rule));
        % Geometry
        geom = field(struct ('name',['geom'], 'dim', 3, 'fens',fens));
        % Define the displacement field
        u   = 0*geom; % zero out
        % Apply EBC's
        ebc_fenids=fenode_select (fens,struct('box',[0,0,0,0,0,0],'inflate',tol));
        ebc_prescribed=ones(1,length (ebc_fenids));
        ebc_comp=[];
        ebc_val=ebc_fenids*0;
        u   = set_ebc(u, ebc_fenids, ebc_prescribed, ebc_comp, ebc_val);
        u   = apply_ebc (u);

        % Number equations
        u   = numbereqns (u);
        % Now comes the nonlinear solution
        tup = 1;
        u = u*0; % zero out the displacement
        v = u*0; % zero out the Velocity
        a = u*0; % zero out the Acceleration
        vxyz = gather(v,(1:length(fens)),'values','noreshape');
        vxyz(:,1) =vini;
        v= scatter (v,(1:length(fens)),vxyz);
        utol = 1e-15*get(u, 'neqns');
        tipu = [];
        
        if graphics, gv=graphic_viewer; end

        K = start (sparse_altassem_sysmat, get(u, 'neqns'));
        M = start (sparse_altassem_sysmat, get(u, 'neqns'));
        Mems=mass(feb, geom, u);% Constant mass matrix
        for  j = 1:length(Mems)
            Mems(j) =set(Mems(j),'mat',get(Mems(j),'mat')/(Newmarkb*dt^2));
        end
        %         K = start (sparse_sysmat, get(u, 'neqns'));

        t=0; % time=load magnitude
        incr=1;
        while (incr <= nincr)
            Report(['Increment ' num2str(incr) ]); % pause
            % Initialization
            u1 = u; % guess
            du = 0*u; % this will hold displacement increment
            u1 = apply_ebc(u1);
            du = apply_ebc(du);
            a1 = -(1/Newmarkb/dt)*v -(1/2-Newmarkb)/Newmarkb*a;
            v1 = v + dt*((1-Newmarkg)*a + Newmarkg*a1);
            F0 = start (sysvec, get(u, 'neqns'));
            ap =-(1/Newmarkb/dt^2)*u -(1/Newmarkb/dt)*v -((1/2-Newmarkb)/Newmarkb)*a;
            F0 = assemble (F0, inertial_force(feb, geom, (-Newmarkb*dt^2)*ap, Mems));
            iter=1;
            if graphics,
                clear(gv,[]); 
                gv=reset(gv,[]);
                draw(feb,gv, struct ('x', geom,'u',u, 'facecolor','cyan'));
                draw(feb,gv, struct ('x', geom,'u',0*u, 'facecolor','Yellow','alpha', 0.2));
                camset(gv,cam);
                 cam =camget(gv);
            end
            while 1
                feb1=feb;
                F = F0;
                [feb1,evs] = restoring_force(feb1,geom,u1,u);       % Internal forces
                F = assemble (F, evs);
                [febstab,evs] = restoring_force_stab(feb1,geom,u1,u,eltyd(eix).stabfact);       % Internal forces
                F = assemble (F, evs);
                F = assemble (F, inertial_force(feb, geom, (-1)*u1, Mems));
                ems=cat(2,stiffness(feb1, geom, u1,u),...
                    stiffness_geo(feb1, geom, u1,u),...
                    stiffness_stab(feb1, geom, u1,u,eltyd(eix).stabfact), ...
                    Mems);
                K =assemble (K,ems);
                K = external_decomposition (K,  []);
                du = scatter_sysvec(du, K\F); % Displacement increment
                %                 max(abs(get(F,'vec')))
                u1 = u1 + du;   % increment displacement
                v1 = v1 + (Newmarkg/Newmarkb/dt)*du;
                a1 = a1 + (1/Newmarkb/dt^2)*du;
                K = reinitialize (K);
                if graphics,
                    draw(feb,gv, struct ('x', geom,'u',u1, 'facecolor','none'));
                    camset (gv,cam); pause(0.5); cam =camget(gv);
                end
                Report(['   It. ' num2str(iter) ': ||du||=' num2str(norm(du))]);
                if (max(abs(gather(du,[],'values'))) < utol) break; end;% convergence check
                if (iter >maxit)% bailout for failed convergence
                    error( [' Possible failed convergence']);
                end
                iter=iter+1;
            end
            [feb,ignore] = restoring_force(feb,geom,u1,u);        % final update
            Report(['    Converged for t=' num2str(t)]); % pause
            u = u1;       % update the displacement
            v = v1;       % update the displacement
            a = a1;      
            norm(a)
%             utip=gather(u,cncl,'values','noreshape');
%             tipu(end +1) = utip(1);
%             plot (tipu); pause(0.01);
            t = t + dt;
            incr = incr + 1;
        end
        if graphics,
            gv=reset(clear(gv,[]),[]);camset (gv,cam); 
            draw(feb,gv, struct ('x', geom,'u',u, 'facecolor','red'));
            draw(feb,gv, struct ('x', geom,'u',0*u, 'facecolor','Yellow'));
        end
        %         camset(gv, [  -75.6602  613.9688  210.2074   20.6651   38.3517 20.5774         0         0    1.0000    5.3084]);
        clear K
        save ([mfilename '-nc' num2str(nc) '-nt' num2str(nt) '-' eltyd(eix).label])
    end

    for nL =nLs
        for eix = 1:length(eltyd)
            for na =nas
                nb=na;
                Compute;
            end
        end
    end
end