font='Times';
Legends = {};

convutip=16.45;% with Richardson extrapolation
refh=44./[4,16,64];
Q4refuerr=abs(convutip-[15.705,16.359,16.476])/convutip;
T3refuerr=abs(convutip-[12.662,15.98,16.391])/convutip;

loglog(refh,Q4refuerr,'ko:','lineWIDTH', 2); hold on;
Legends{end+1} ='Q4E6/Q4';

loglog(refh,T3refuerr,'k<:','lineWIDTH', 2); hold on;
Legends{end+1} ='T3E4(I)/T3';

data=[11.0000    5.5000    2.7500    1.3750
   13.5977   15.4813   16.1189   16.3284
    ];
h=data(1,:);utip=abs(convutip-data(2,:))/convutip;
loglog(h,utip,'ks--','lineWIDTH', 2); hold on;
Legends{end+1} ='Q4-SRI';

data=[22.0000   11.0000    5.5000    2.7500
   12.679793156997697  15.638419213155577  16.250881864356661  16.377621366959936
    ];
h=data(1,:);utip=abs(convutip-data(2,:))/convutip;
loglog(h,utip,'kx-','lineWIDTH', 2); hold on;
Legends{end+1} ='T6';

data=[11.0000    5.5000    2.7500    1.3750
   11.9069   14.9018   15.8870   16.2090
    ];
h=data(1,:);utip=abs(convutip-data(2,:))/convutip;
loglog(h,utip,'md-','lineWIDTH', 2); hold on;
Legends{end+1} ='NICE-Q4';

data=[11.0000    5.5000    2.7500    1.3750
   17.4473   16.9611   16.6338   16.5134
    ];
h=data(1,:);utip=abs(convutip-data(2,:))/convutip;
loglog(h,utip,'m^-','lineWIDTH', 2); hold on;
Legends{end+1} ='NICE-T3';

data=[22.0000   11.0000    5.5000    2.7500
   13.913537060803462  16.053062648436480  16.364851470013239  16.420441284554553
    ];
h=data(1,:);utip=abs(convutip-data(2,:))/convutip;
loglog(h,utip,'rh-','lineWIDTH', 2); hold on;
Legends{end+1} ='NICE-T6';

set(gca,'XLim', [0.2, 30]);
xlabel ('mesh size')
ylabel ('normalized displ error')
legend(Legends,'Location','Northwest')
set(gca,'Position',[0.15 0.15 0.5 0.5]);
set_label_defaults
hold on; grid on; figure (gcf);
% saveas(gcf,[mfilename '.png']);
 printeps(gcf,[mfilename '.eps']);
 close  all