font='Times';
Legends = {};
Data = {};
Style = {};

% loadv=[0;0;p];dir=3;
uzex=5.426e-3;
% loadv=[0;p;0];dir=2;uzex=1.756e-3;

Data{end+1}=[
   2.0000e+000   2.0000e+001
  uzex uzex
]; Style{end+1}='k--'; Legends{end+1} ='Ref';


%NICE-T4: number of equations =108
%     Normalized displacement =0.81981
%NICE-T4: number of equations =600
%     Normalized displacement =1.078
%NICE-T4: number of equations =1764
%     Normalized displacement =1.0483
%NICE-T4: number of equations =3888
%     Normalized displacement =1.0302
Data{end+1}=[
  4.0000e+000  8.0000e+000  1.2000e+001  1.6000e+001
  4.4483e-003  5.8490e-003  5.6882e-003  5.5899e-003

];Style{end+1}='m^-';Legends{end+1} ='NICE-T4';
%NICE-H8: number of equations =108
%     Normalized displacement =0.72335
%NICE-H8: number of equations =600
%     Normalized displacement =0.89703
%NICE-H8: number of equations =1764
%     Normalized displacement =0.94648
%NICE-H8: number of equations =3888
%     Normalized displacement =0.96665
Data{end+1}=[
  4.0000e+000  8.0000e+000  1.2000e+001  1.6000e+001
  3.9249e-003  4.8673e-003  5.1356e-003  5.2450e-003

];Style{end+1}='md-';Legends{end+1} ='NICE-H8';

%T10: number of equations =108
%     Normalized displacement =0.47132
%T10: number of equations =600
%     Normalized displacement =0.89888
%T10: number of equations =1764
%     Normalized displacement =0.96462
Data{end+1}=[
  2.0000e+000  4.0000e+000  6.0000e+000
  2.5574e-003  4.8773e-003  5.2340e-003

];Style{end+1}='kv--';Legends{end+1} ='T10';
%H27: number of equations =108
%     Normalized displacement =0.66586
%H27: number of equations =600
%     Normalized displacement =0.92629
%H27: number of equations =1764
%     Normalized displacement =0.97459
Data{end+1}=[
  2.0000e+000  4.0000e+000  6.0000e+000
  3.6130e-003  5.0260e-003  5.2881e-003

];Style{end+1}='ks-';Legends{end+1} ='H27';
%NICE-H27: number of equations =108
%     Normalized displacement =0.86258
%NICE-H27: number of equations =600
%     Normalized displacement =0.97549
%NICE-H27: number of equations =1764
%     Normalized displacement =0.98804
Data{end+1}=[
  2.0000e+000  4.0000e+000  6.0000e+000
  4.6804e-003  5.2930e-003  5.3611e-003

];Style{end+1}='mh-';Legends{end+1} ='NICE-H27';
%H20R: number of equations =72
%     Normalized displacement =0.92958
%H20R: number of equations =360
%     Normalized displacement =0.98922
%H20R: number of equations =1008
%     Normalized displacement =0.99649
Data{end+1}=[
  2.0000e+000  4.0000e+000  6.0000e+000
  5.0439e-003  5.3675e-003  5.4070e-003

];Style{end+1}='ro-';Legends{end+1} ='H20R';
%NICE-H20: number of equations =72
%     Normalized displacement =0.7325
%NICE-H20: number of equations =360
%     Normalized displacement =0.92097
%NICE-H20: number of equations =1008
%     Normalized displacement =0.9681
Data{end+1}=[
  2.0000e+000  4.0000e+000  6.0000e+000
  3.9746e-003  4.9972e-003  5.2529e-003

];Style{end+1}='mo--';Legends{end+1} ='NICE-H20';
%H20: number of equations =72
%     Normalized displacement =0.64465
%H20: number of equations =360
%     Normalized displacement =0.91778
%H20: number of equations =1008
%     Normalized displacement =0.97198
Data{end+1}=[
  2.0000e+000  4.0000e+000  6.0000e+000
  3.4979e-003  4.9799e-003  5.2740e-003

];Style{end+1}='k>--';Legends{end+1} ='H20';

%NICE-H8 u: number of equations =1170
%     Normalized displacement =0.45012
%NICE-H8 u: number of equations =2340
%     Normalized displacement =0.79578
%NICE-H8 u: number of equations =3510
%     Normalized displacement =0.89577
%NICE-H8 u: number of equations =4680
%     Normalized displacement =0.93712
Data{end+1}=[
    6.0000   12.0000   18.0000   24.0000
    0.0024    0.0043    0.0049    0.0051

];Style{end+1}='md--';Legends{end+1} ='NICE-H8 u';

for j=1:length(Data)
    data=Data{j};
    h=data(1,:); utip=data(2,:);
%     plot(h,utip,Style{j},'lineWIDTH', 3); hold on;
    loglog(h,abs(utip-uzex)/uzex,Style{j},'lineWIDTH', 3); hold on;
end

% set(gca,'XLim', [100, 1000]);
% set(gca,'YLim', [1e-4, 1e-1]);
xlabel ('number of elements per side')
ylabel ('displacement')
legend(Legends,'Location','Southeast')
set(gca,'Position',[0.15 0.15 0.5 0.5]);
set(gca,'FontSize',12);
set(gca,'FontName',font)
l=get(gca,'xlabel');
set (l,'FontSize',14);
set(l,'FontName',font)
l=get(gca,'ylabel');
set (l,'FontSize',14);
set(l,'FontName',font)
hold on; grid on; figure (gcf);
saveas(gcf,[mfilename '.eps'],'eps2c');