font='Times';
Legends = {};
Data = {};
Style = {};

% loadv=[0;0;p];dir=3;
uzex=5.426e-3;
% loadv=[0;p;0];dir=2;uzex=1.756e-3;

Data{end+1}=[
   .0000e+000   6000.0000e+00
  uzex uzex
]; Style{end+1}='k--'; Legends{end+1} ='Ref';


%NICE-T4: number of equations =72
%     Normalized displacement =0.88372
%NICE-T4: number of equations =324
%     Normalized displacement =1.4597
%NICE-T4: number of equations =864
%     Normalized displacement =1.2082
%NICE-T4: number of equations =1800
%     Normalized displacement =1.1225
%NICE-T4: number of equations =3240
%     Normalized displacement =1.079
%NICE-T4: number of equations =5292
%     Normalized displacement =1.0559
Data{end+1}=[
   864, 1800, 3240, 5292
    0.006555536494285   0.006090429011383 0.005854877647806   0.005729300080127

];Style{end+1}='m^-';Legends{end+1} ='NICE-T4';

%NICE-H8: number of equations =72
%     Normalized displacement =0.31468
%NICE-H8: number of equations =324
%     Normalized displacement =0.66476
%NICE-H8: number of equations =864
%     Normalized displacement =0.8122
%NICE-H8: number of equations =1800
%     Normalized displacement =0.88524
%NICE-H8: number of equations =3240
%     Normalized displacement =0.92218
%NICE-H8: number of equations =5292
%     Normalized displacement =0.94434
Data{end+1}=[
 864, 1800, 3240, 5292
      0.004406971593310   0.004803301865664 0.005003726692216   0.005124014726643

];Style{end+1}='md-';Legends{end+1} ='NICE-H8';

%NICE-H8 u: number of equations =360
%     Normalized displacement =0.36541
%NICE-H8 u: number of equations =720
%     Normalized displacement =0.7518
%NICE-H8 u: number of equations =3510
%     Normalized displacement =0.89577
%NICE-H8 u: number of equations =4680
%     Normalized displacement =0.93712
%NICE-H8 u: number of equations =12240
%     Normalized displacement =0.92947
%NICE-H8 u: number of equations =14688
%     Normalized displacement =0.9389
Data{end+1}=[
 720, 3510, 4680, 
    0.004079253374176   0.004860468453389   0.005084787631701 

];Style{end+1}='md--';Legends{end+1} ='NICE-H8 u';


%NICE-H27: number of equations =2232
%     Normalized displacement =0.92794
%NICE-H27: number of equations =4464
%     Normalized displacement =0.98746

%NICE-H27: number of equations =1488
%     Normalized displacement =0.77357
%NICE-H27: number of equations =2976
%     Normalized displacement =0.96794


%H27: number of equations =1488
%     Normalized displacement =0.61481
%H27: number of equations =2976
%     Normalized displacement =0.95907
Data{end+1}=[
  1488, 2976,4464
  [0.61481,0.9507, 0.9711]*uzex

];Style{end+1}='ks--';Legends{end+1} ='H27 u';

Data{end+1}=[
  1488,2232,2976,4464
  [0.77357,0.92794,0.96794,0.98746]*uzex
];Style{end+1}='mh--';Legends{end+1} ='NICE-H27 u';

%H27: number of equations =108
%     Normalized displacement =0.66586
%H27: number of equations =600
%     Normalized displacement =0.92629
%H27: number of equations =1764
%     Normalized displacement =0.97459
Data{end+1}=[
  108, 600, 1764
  [0.66586, 0.92629, 0.97459]*uzex

];Style{end+1}='ks-';Legends{end+1} ='H27';
%NICE-H27: number of equations =108
%     Normalized displacement =0.86258
%NICE-H27: number of equations =600
%     Normalized displacement =0.97549
%NICE-H27: number of equations =1764
%     Normalized displacement =0.98804
Data{end+1}=[
  108, 600, 1764
    [0.86258,0.97549,0.98804]*uzex

];Style{end+1}='mh-';Legends{end+1} ='NICE-H27';

for j=1:length(Data)
    data=Data{j};
    h=data(1,:); utip=data(2,:);
    plot(h,utip,Style{j},'lineWIDTH', 2); hold on;
%     loglog(h,abs(utip-uzex)/uzex,Style{j},'lineWIDTH', 3); hold on;
end

% set(gca,'XLim', [100, 1000]);
set(gca,'YLim', [0e-4,70e-4]);
xlabel ('number of equations')
ylabel ('displacement')
legend(Legends,'Location','Southeast')
set(gca,'Position',[0.15 0.15 0.5 0.5]);
set_label_defaults
hold on; grid on; figure (gcf);
% saveas(gcf,[mfilename '.png']);
 printeps(gcf,[mfilename '.eps']);