function B = feblock_defor_ss_divmat3(self,N,Ndersp,c,Rm)
    nfn= size(Ndersp,1);
    B = zeros(1,nfn*3);
    if (isempty(Rm)) % there is no global-to-local transformation
        for i= 1:nfn
            B(:,3*(i-1)+1:3*i)  = [ Ndersp(i,1)  Ndersp(i,2)  Ndersp(i,3) ];
        end
    else % global-to-local transformation is requested
        RmT=Rm';
        for i= 1:nfn
            B(:,3*(i-1)+1:3*i)  = [ Ndersp(i,1)  Ndersp(i,2)  Ndersp(i,3) ]*RmT;
        end
    end
end



