% Are given parametric coordinates inside the element parametric domain?
% 
% function val = in_parametric(self,param_coords)
% 
%  The parametric domain is the standard triangle.  
% 
% Returns a Boolean: is the point inside, true or false?
% 
function val = in_parametric(self,param_coords)
    s =intersect(find(param_coords>=0),find(param_coords<=1));
    val = (length(s)==length(param_coords))&&(sum(param_coords)<=1);
end



