% Get property from the specified object and return the value.
%
% function val = get(self,varargin)
%
% See discussion of the get/set methods in <a href="matlab:helpwin
% 'FAESOR/classes/Contents'">classes/Contents</a>. 
%
function val = get(self,varargin)
    if (nargin == 1)
        val = {{{'electrical_conductivity'}, {'conductivity matrix, [d,d], where d=1, 2, or 3'}};...
            };
        val = cat(1, val, get(self.property));
        return;
    else
        prop_name=varargin{1};
        switch prop_name
            case 'electrical_conductivity'
                val = self.electrical_conductivity;
            otherwise
                val = get(self.property, prop_name);
        end
    end
end
