syms a b c d  x 'real'
% Cubic polynomial
p=sum(x.^(3:-1:0).*[a, b, c, d])
dp=diff(p)

% Hermite basis functions
syms a b c d  x 'real'
sol=solve(subs(p,x,-1)-1,subs(dp,x,-1),subs(p,x,+1),subs(dp,x,+1),a, b, c, d);
a=sol.a;b=sol.b;c=sol.c;d=sol.d;
p0=subs(p);
p1=1-p0;
syms a b c d  x 'real'
sol=solve(subs(dp,x,-1)-1,subs(p,x,-1),subs(dp,x,+1),subs(p,x,+1),a, b, c, d);
a=sol.a;b=sol.b;c=sol.c;d=sol.d;
o0=subs(p);
syms a b c d  x 'real'
sol=solve(subs(dp,x,-1),subs(p,x,-1),subs(dp,x,+1)-1,subs(p,x,+1),a, b, c, d);
a=sol.a;b=sol.b;c=sol.c;d=sol.d;
o1=subs(p);
% plot them
fplot(char(p0),[-1 +1],'r-')
hold on
fplot(char(p1),[-1 +1],'g-')
fplot(char(o0),[-1 +1],'b-')
fplot(char(o1),[-1 +1],'m-')

horner(p0)
horner(p1)
horner(o0)
horner(o1)
