% DEFORMATION
%
% Files
%   ArgyrLFrameIn       - Argyris L-frame, in-plane load
%   ArgyrLFrameOut      - Argyris L-frame, out-of-plane load
%   CCB_distributed_x2  - Clamped-clamped beam with distributed load. Soft axis bending
%   CCB_distributed_x3  - Clamped-clamped beam with distributed load. Stiff axis bending
%   circarc             - Circular arc, static deflection out of plane
%   CorotArgyrLFrameIn  - Argyris L-frame, in-plane load. Corotational beam
%   CorotArgyrLFrameOut - Argyris L-frame, out-of-plane load. Corotational beam
%   Corotcircarc        - Circular arc, static deflection out of plane.Corotational beam
%   DaDeppoSchmidt      - Da Deppo, Schmidt circular arc 
%   elnasizz            - lzzuddin, Elnashai Dome frame
%   SSB_distributed_x2  - Simply-supported beam with distributed load. Soft axis bending.
%   SSB_distributed_x3  - Simply-supported beam with distributed load. Stiff  axis bending.
%   stival1             - STI validation example #1
%   stival2             - STI validation example #1
%   stival3             - STI validation example #3
