% Compute the bounding box of a collection of points.
% 
% function box = bounding_box (x)
% 
% x= array of locations, one per row
% 
function box = bounding_box (x)
    box=zeros(1,2*size(x,2));
    for i=1:size(x,2)
        box(2*i-1)=min(x(:,i));
        box(2*i)=max(x(:,i));
    end
end
